/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumCalculated;
import de.ship.db.tables.records.VDmCalcVarAddRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmCalcVarAdd extends TableImpl<VDmCalcVarAddRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_calc_var_add</code>
     */
    public static final VDmCalcVarAdd V_DM_CALC_VAR_ADD = new VDmCalcVarAdd();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmCalcVarAddRecord> getRecordType() {
        return VDmCalcVarAddRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_calc_var_add.var_element</code>.
     */
    public final TableField<VDmCalcVarAddRecord, Integer> VAR_ELEMENT = createField(DSL.name("var_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.calc_order</code>.
     */
    public final TableField<VDmCalcVarAddRecord, Integer> CALC_ORDER = createField(DSL.name("calc_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.calc_tool</code>.
     */
    public final TableField<VDmCalcVarAddRecord, EnumCalculated> CALC_TOOL = createField(DSL.name("calc_tool"), SQLDataType.VARCHAR.asEnumDataType(EnumCalculated.class), this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.fk_tabledef</code>.
     */
    public final TableField<VDmCalcVarAddRecord, Integer> FK_TABLEDEF = createField(DSL.name("fk_tabledef"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.var_short_name</code>.
     */
    public final TableField<VDmCalcVarAddRecord, String> VAR_SHORT_NAME = createField(DSL.name("var_short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.group_name</code>.
     */
    public final TableField<VDmCalcVarAddRecord, String> GROUP_NAME = createField(DSL.name("group_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.table_element</code>.
     */
    public final TableField<VDmCalcVarAddRecord, Integer> TABLE_ELEMENT = createField(DSL.name("table_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_calc_var_add.table_name</code>.
     */
    public final TableField<VDmCalcVarAddRecord, String> TABLE_NAME = createField(DSL.name("table_name"), SQLDataType.CLOB, this, "");

    private VDmCalcVarAdd(Name alias, Table<VDmCalcVarAddRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmCalcVarAdd(Name alias, Table<VDmCalcVarAddRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_calc_var_add" as  SELECT vc.fk_variable AS var_element,
         vc.calc_order,
         vc.calc_tool,
         vc.fk_tabledef,
         eh.short_name AS var_short_name,
         vt.group_name,
         vt.fk_element AS table_element,
         vt.short_name AS table_name
        FROM (((common_dd.t_dm_calculated vc
          LEFT JOIN common_dd.v_core_element_tree eh ON ((vc.fk_variable = eh.key_element)))
          LEFT JOIN common_dd.t_dm_tabledef td ON ((vc.fk_tabledef = td.pk)))
          LEFT JOIN common_dd.v_dm_tablegroup vt ON ((td.fk_element = vt.fk_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_calc_var_add</code> table
     * reference
     */
    public VDmCalcVarAdd(String alias) {
        this(DSL.name(alias), V_DM_CALC_VAR_ADD);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_calc_var_add</code> table
     * reference
     */
    public VDmCalcVarAdd(Name alias) {
        this(alias, V_DM_CALC_VAR_ADD);
    }

    /**
     * Create a <code>common_dd.v_dm_calc_var_add</code> table reference
     */
    public VDmCalcVarAdd() {
        this(DSL.name("v_dm_calc_var_add"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmCalcVarAdd as(String alias) {
        return new VDmCalcVarAdd(DSL.name(alias), this);
    }

    @Override
    public VDmCalcVarAdd as(Name alias) {
        return new VDmCalcVarAdd(alias, this);
    }

    @Override
    public VDmCalcVarAdd as(Table<?> alias) {
        return new VDmCalcVarAdd(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmCalcVarAdd rename(String name) {
        return new VDmCalcVarAdd(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmCalcVarAdd rename(Name name) {
        return new VDmCalcVarAdd(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmCalcVarAdd rename(Table<?> name) {
        return new VDmCalcVarAdd(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmCalcVarAdd where(Condition condition) {
        return new VDmCalcVarAdd(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmCalcVarAdd where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmCalcVarAdd where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmCalcVarAdd where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmCalcVarAdd where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmCalcVarAdd where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmCalcVarAdd where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmCalcVarAdd where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmCalcVarAdd whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmCalcVarAdd whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
